/*
	[ ZE ] Game:Mode : Killer
	When Infect Zombie Become Killer !
	Escapers-Zone.NET
*/

#include < zombie_escape >

#define ADMIN_ACCESS ADMIN_LEVEL_H
#define SOUND_MAX_LENGHT 32

// Setting File
new const ZE_SETTING[] = "zombie_escape.ini"

// Default Sound
new iSoundRound[ ][ ] =
{
	"ambience/the_horror2.wav"
}

// Array
new Array:g_iSoundRound

// Variable
new pcvar_chance, pcvar_kb
new gMaxPlayers

// Bool
new bool:gKiller
new bool:iNextKiller

public plugin_init() {
	
	// Load Plugin
	register_plugin( "[ ZE ] Gamemode:Killer", "1.2", "LiZou Mapper")
	
	// Event
	register_event( "HLTV", "EventNewRound", "a", "1=0", "2=0" )
	
	// Clcmds
	register_clcmd( "ze_killers_next", "cmdKillers", ADMIN_ACCESS, "< Round Killers >" )
	
	// Cvars
	pcvar_chance = register_cvar( "ze_killer_chance", "15" )
	pcvar_kb = register_cvar( "ze_killer_knockback", "300" )
	
	// Dictionnary 
	register_dictionary( "zombie_escape.txt" )
	
	// More
	gMaxPlayers = get_maxplayers( )
	
}

public plugin_natives( ) 
{
	register_native( "ze_start_kround", "_native_ze_start_killerround", 1)
	register_native("ze_start_kround_next", "_native_ze_start_kround_next", 1)
	register_native("ze_is_round_killers", "_native_ze_is_round_killers", 1)
}

public plugin_precache( ) 
{
	g_iSoundRound = ArrayCreate(SOUND_MAX_LENGHT, 1)
	
	amx_load_setting_string_arr(ZE_SETTING, "Sounds", "GAMEMODE KILLERS", g_iSoundRound)
	
	new iIndex
	
	if(ArraySize(g_iSoundRound) == 0)
	{
		for(iIndex = 0;iIndex < sizeof iSoundRound;iIndex++)
			ArrayPushString(g_iSoundRound, iSoundRound[iIndex])
			
		amx_save_setting_string_arr(ZE_SETTING, "Sounds", "GAMEMODE KILLERS", g_iSoundRound)
	}
	
	new Sound[SOUND_MAX_LENGHT]
	
	for(iIndex = 0;iIndex < ArraySize(g_iSoundRound);iIndex++)
	{
		ArrayGetString(g_iSoundRound, iIndex, Sound, charsmax(Sound))
		
		if(equal(Sound[strlen(Sound)-4], ".mp3"))
		{
			format(Sound, charsmax(Sound), "sound/%s", Sound)
			precache_generic(Sound)
		} 
		else
		{
			precache_sound(Sound)
		}
	}
}
	
public EventNewRound( id ) 
{
	// If chance = 1 start round nemesis
	if( random_num(1, get_pcvar_num( pcvar_chance ) ) == 1 )
	{
		gKiller = true 
	}
}

public ze_game_started_pre()
{
	while( iNextKiller )
	{
		iNextKiller = false
		gKiller = true
		return PLUGIN_HANDLED
	}
	
	return PLUGIN_CONTINUE
}

public cmdKillers( id, level, cid ) 
{
	if( !cmd_access(id, ADMIN_ACCESS, cid, 0) )
	{
		client_print(id, print_console, "You have not acess !")
		return PLUGIN_HANDLED
	}
	
	iNextKiller = true
	client_print(id, print_console, "Killers round will start next round.")
	return PLUGIN_CONTINUE
}

public ze_user_infected_pre( iVictim, iInfector )
{
	// if round killer started, make zombie killer
	if( gKiller )
	{
		// set knockback 
		ze_set_user_knockback(iVictim, get_pcvar_float(pcvar_kb))
		
		// Credits : Mohamed Alaa
		ExecuteHamB( Ham_Killed, iVictim, iInfector, 0 )
		Effect( )
		return 1;	
	}
	
	return PLUGIN_CONTINUE
}

public ze_roundend( ) 
{
	for(new id ; id < gMaxPlayers ;id++ )
	{
		// turn off round killer 
		gKiller = false
		
		// reset kb 
		ze_reset_user_knockback(id)
	}
}

Effect( )	
{
	for( new id; id < gMaxPlayers; id++ )
	{
		if( gKiller )
		{
			static LangHUD[ 64 ] 
			
			// Message Round Killers
			formatex( LangHUD, charsmax( LangHUD ), "%L", LANG_PLAYER, "GAMEMODE_KILLER" )
			set_hudmessage( 0, 255, 0, -1.0, 0.25, 1, 6.0, 5.0, 0.5, 1.5 )
			show_hudmessage( id, LangHUD )
			
			// Sound Round Killer
			new iSound[SOUND_MAX_LENGHT]
			ArrayGetString(g_iSoundRound, random_num(0, ArraySize(g_iSoundRound)-1), iSound, charsmax(iSound))
			PlaySound(id, iSound)
		}
	}
}
	
public _native_ze_is_round_killers(iPlugin, iParam)
{
	return gKiller = true
}

public _native_ze_start_killerround(id)
{
	if(!is_user_connected(id))
	{
		log_error(AMX_ERR_NATIVE, "[ZE] Invalid Player id (%d)", id)
		return false
	}
	
	gKiller = true
	return true
}

public _native_ze_start_kround_next()
{
	iNextKiller = true
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1033\\ f0\\ fs16 \n\\ par }
*/
